chiark / gitweb /
Test suite: Make t-expect-push-fail out of the remains of mustfail
[dgit.git] / tests / tests / drs-push-rejects
index f6f8882979e5b29ef79a089ba9915d76228fd970..e80620daafe11233289f6a81727688d193ae6923 100755 (executable)
@@ -10,37 +10,16 @@ t-worktree drs
 
 cd $p
 
-reporefs () {
-       (set -e
-       if test -d $tmp/git/$p.git; then
-               cd $tmp/git/$p.git
-               git show-ref
-       fi)
-}
-
 mustfail () {
-       local wantmsg="$1"; shift
-       reporefs >$tmp/show-refs.pre-push
-       set +e
-       git push origin "$@" 2>&1 |tee $tmp/mustfail.txt
-       ps="${PIPESTATUS[*]}"
-       set -e
-       case $ps in
-       "0 0")  fail "push unexpectedly succeeded (instead of: $wantmsg)" ;;
-       *" 0")  ;;
-       *)      fail "tee failed"  ;;
-       esac
-       if ! fgrep "$wantmsg" $tmp/mustfail.txt >/dev/null; then
-               fail "error message not found"
-       fi
-       reporefs >$tmp/show-refs.post-push
-       diff $tmp/show-refs.{pre,post}-push
+       local mpat="$1"; shift
+       t-expect-push-fail "$mpat" \
+       git push origin "$@"
 }
 
 mustsucceed () {
-       reporefs >$tmp/show-refs.pre-push
+       t-reporefs pre-push
        git push origin "$@"
-       reporefs >$tmp/show-refs.post-push
+       t-reporefs post-push
        if diff $tmp/show-refs.{pre,post}-push >$tmp/show-refs.diff; then
                fail "no refs updated"
        fi
@@ -86,7 +65,7 @@ for h in object type tag; do
     cat badtag.asc >>badtag
 
     set +e
-    LC_ALL=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
+    LC_MESSAGES=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
     rc=$?
     set -e
 
@@ -159,8 +138,13 @@ prep unstable sid
 mktag
 mustsucceed $push_spec # succeeds
 
+mktag
+mustfail 'push is missing head ref update' $push_spec
+
+git commit --allow-empty -m 'Dummy update'
 mktag
 mustfail 'not replacing previously-pushed version' $push_spec
+git reset --hard HEAD~
 
 prep_dm_mangle () {
        prep unstable sid